'use strict';

var Ftp = require('./jsftp');
var poolModule = require('generic-pool');

function createPool(max, ftpCfg) {
  return poolModule.Pool({
    name: 'ftp',
    create: function(cb) {
      cb(null, new Ftp(ftpCfg));
    },
    idleTimeoutMillis: 30000,
    max: max,
    destroy: function(ftp) { ftp.destroy(); }
  });
}

module.exports = {
  createPool: createPool
};
