Node-exploitsearch-client
=========================
A [Node.js](http://nodejs.org/) (JavaScript) library for accessing [Exploitsearch.net](http://www.exploitsearch.net/) API. It was designed to be included in [Bluebox-ng](https://github.com/jesusprubio/bluebox-ng) 2.0 version.

- **GitHub repo**: [https://github.com/jesusprubio/node-exploitsearch-client](https://github.com/jesusprubio/node-shodan-client)
- **IRC(Freenode)**: #breakingVoIP

Use
---
This module has next dependencies (included in "package.json" file):

- **[request](https://github.com/mikeal/request)**

```javascript
var ExploitSearch = require('exploitsearch'),
    options      = {
        timeout  : 8000
    },
    client = new ExploitSearch(options);

// we only want exploits now, not vulns
options.exploits = true;

client.search('freepbx', function (err, data) {
    if (err) {
        console.log('ERROR: client.search: ' + err);
    } else {
        console.log(data);
    }
});
```
[**Full examples**](https://github.com/jesusprubio/node-exploitsearch-client/tree/master/examples)

Developer guide
---------------
- Use JavaScript (Coffee only used in some examples).
- Respect the ".jshintrc" included file or CoffeeLint default options.
- Use [GitHub pull requests](https://help.github.com/articles/using-pull-requests).

TODO
----
- [https://github.com/jesusprubio/node-exploitsearch-client/issues](https://github.com/jesusprubio/node-exploitsearch-client/issues)

License
-------
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
