/*

Copyright (C) 2013, Jesus Perez <jesusprubio gmail com>

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
'use strict';

var request = require('request'),
    util    = require('util');

function ExploitSearchClient (options) {
    this.exploits = options.exploits || false;
    this.timeout  = options.timeout || 5000;
}

ExploitSearchClient.prototype.search = function (query, callback) {
    var baseUrl       = 'http://www.exploitsearch.net/json.php?q=',
        exploits      = 0,
        // to avoid blocking
        customAgent   = 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_9_0) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/31.0.1650.63 Safari/537.36',
        customHeaders = {
            'User-Agent' : customAgent
        },
        options, err;

    if (this.exploits) {
        exploits = 1;
    }
    options = {
        uri     : baseUrl + query + '&e=' + exploits,
        method  : 'GET',
        headers : customHeaders,
        json    : true,
        timeout : this.timeout
    };
    request.get(options, function (error, response, body) {
        if (!error && response.statusCode === 200) {
            callback(null, body);
        }
        else {
            err = 'request.get: ' + error;
            if (response && response.statusCode) {
                err = err + ' (code: ' + response.statusCode + ')';
            }
            callback(err);
        }
    });
};

module.exports = ExploitSearchClient;
