/*

Copyright (C) 2013, Jesus Perez <jesusprubio gmail com>

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
'use strict';

var util = require('util'),
    
    ShodanClient = require('../lib/shodan.js'),
    options      = {
        key     : 'YOURKEYHEREEEEEEEEEEEEEEE',
        timeout : 15000
    },
    shodanClient = new ShodanClient(options),
    searchOptions,
    countOptions;


// ---------------------- EXPLOITS API ----------------------
// https://developer.shodan.io/api/exploits/rest

// ------------------- EXPLOITSEARCH -------------------
// minimal required parameters
//searchOptions = {
//    query: 'freepbx'
//};

// full supported params
searchOptions = {
    query: 'asterisk',
    facets: 'port:100',
    page: 1
};

shodanClient.exploitSearch(searchOptions,  function (err, data) {
    console.log('\n------------------- exploitSearch -------------------');
    if (err) {
        console.log('ERROR: shodanClient.exploitSearch: ' + err);
    } else {
        console.log(util.inspect(data, { showHidden: true, depth: 4 }));
    }
});

// ------------------- EXPLOITCOUNT -------------------
// minimal required parameters
//countOptions = {
//    query: 'freepbx'
//};

// full supported params
countOptions = {
    query: 'asterisk',
    facets: 'port:100'
};

shodanClient.exploitCount(countOptions,  function (err, data) {
    console.log('\n------------------- exploitCount -------------------');
    if (err) {
        console.log('ERROR: shodanClient.exploitCount: ' + err);
    } else {
        console.log(util.inspect(data, { showHidden: true, depth: 4 }));
    }
});